% $Id: ITreeMapTest.oz,v 1.2 2012/03/27 16:07:37 leavens Exp leavens $
\insert 'ITreeMap.oz'
\insert 'TestingNoStop.oz'

local
   % Just for testing, you don't have to implement ITreeTake
   % ITreeTake: <fun {$ <ITree S T> <Int>}: <Tree S T>>
   fun {ITreeTake T Level}
      if Level == 0
      then leaf
      else case T of
              tree(key: K answer: A left: L right: R) then
              tree(key: K answer: A left: {ITreeTake L Level-1} right: {ITreeTake R Level-1})
           end
      end
   end
   % Just for testing, you don't have to implement ITreeGenerate
   % This is lazy because that's the easiest way to generate
   % new dataflow variables for subtrees, and control it.
   % ITreeGenerate: <fun lazy {$ <T> <fun {$ <S>}: T> <fun {$ <T>}: <T>}: <ITree <T> <T>>>
   fun lazy {ITreeGenerate InitialK LeftFun RightFun}
      tree(key: InitialK answer: _ % an undetermined dataflow variable
           left: {ITreeGenerate {LeftFun InitialK} LeftFun RightFun}
           right: {ITreeGenerate {RightFun InitialK} LeftFun RightFun})
   end
in
   {StartTesting 'ITreeMapTest.oz $Revision: 1.2 $'}
   {Test {ITreeTake {ITreeMap {ITreeGenerate 1 fun {$ K} K+2 end fun {$ K} K+3 end} fun {$ K} K*10 end}
          3}
    '==' tree(key: 1 answer: 10
              left: tree(key: 3 answer: 30
                         left: tree(key: 5 answer: 50 left: leaf right: leaf)
                         right: tree(key: 6 answer: 60 left: leaf right: leaf))
              right: tree(key: 4 answer: 40
                         left: tree(key: 6 answer: 60 left: leaf right: leaf)
                         right: tree(key: 7 answer: 70 left: leaf right: leaf)))}
   {Test {ITreeTake {ITreeMap {ITreeGenerate 5 fun {$ K} K*2 end fun {$ K} K*3 end} fun {$ K} K*100 end}
          4}
    '==' tree(key: 5 answer: 500
              left: tree(key: 10 answer: 1000
                         left: tree(key: 20 answer: 2000
                                    left: tree(key: 40 answer: 4000 left: leaf right: leaf)
                                    right: tree(key: 60 answer: 6000 left: leaf right: leaf))
                         right: tree(key: 30 answer: 3000
                                     left: tree(key: 60 answer: 6000 left: leaf right: leaf)
                                     right: tree(key: 90 answer: 9000 left: leaf right: leaf)))
              right: tree(key: 15 answer: 1500
                          left: tree(key: 30 answer: 3000
                                     left: tree(key: 60 answer: 6000 left: leaf right: leaf)
                                     right: tree(key: 90 answer: 9000 left: leaf right: leaf))
                          right: tree(key: 45 answer: 4500
                                      left: tree(key: 90 answer: 9000 left: leaf right: leaf)
                                      right: tree(key: 135 answer: 13500 left: leaf right: leaf))))}
   {DoneTesting}
end
